<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>21.14. poplib — POP3 protocol client &mdash; Python 3.5.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/pydoctheme.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '3.5.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/sidebar.js"></script>
    <link rel="search" type="application/opensearchdescription+xml"
          title="Search within Python 3.5.1 documentation"
          href="../_static/opensearch.xml"/>
    <link rel="author" title="About these documents" href="../about.html" />
    <link rel="copyright" title="Copyright" href="../copyright.html" />
    <link rel="top" title="Python 3.5.1 documentation" href="../contents.html" />
    <link rel="up" title="21. Internet Protocols and Support" href="internet.html" />
    <link rel="next" title="21.15. imaplib — IMAP4 protocol client" href="imaplib.html" />
    <link rel="prev" title="21.13. ftplib — FTP protocol client" href="ftplib.html" />
    <link rel="shortcut icon" type="image/png" href="../_static/py.png" />
    <script type="text/javascript" src="../_static/copybutton.js"></script>
    <script type="text/javascript" src="../_static/version_switch.js"></script>
    
 

  </head>
  <body role="document">  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="imaplib.html" title="21.15. imaplib — IMAP4 protocol client"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="ftplib.html" title="21.13. ftplib — FTP protocol client"
             accesskey="P">previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="internet.html" accesskey="U">21. Internet Protocols and Support</a> &raquo;</li> 
      </ul>
    </div>    

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="module-poplib">
<span id="poplib-pop3-protocol-client"></span><h1>21.14. <a class="reference internal" href="#module-poplib" title="poplib: POP3 protocol client (requires sockets)."><code class="xref py py-mod docutils literal"><span class="pre">poplib</span></code></a> &#8212; POP3 protocol client<a class="headerlink" href="#module-poplib" title="Permalink to this headline">¶</a></h1>
<p id="index-0"><strong>Source code:</strong> <a class="reference external" href="https://hg.python.org/cpython/file/3.5/Lib/poplib.py">Lib/poplib.py</a></p>
<hr class="docutils" />
<p>This module defines a class, <a class="reference internal" href="#poplib.POP3" title="poplib.POP3"><code class="xref py py-class docutils literal"><span class="pre">POP3</span></code></a>, which encapsulates a connection to a
POP3 server and implements the protocol as defined in <span class="target" id="index-1"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc1939.html"><strong>RFC 1939</strong></a>. The
<a class="reference internal" href="#poplib.POP3" title="poplib.POP3"><code class="xref py py-class docutils literal"><span class="pre">POP3</span></code></a> class supports both the minimal and optional command sets from
<span class="target" id="index-2"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc1939.html"><strong>RFC 1939</strong></a>. The <a class="reference internal" href="#poplib.POP3" title="poplib.POP3"><code class="xref py py-class docutils literal"><span class="pre">POP3</span></code></a> class also supports the <code class="docutils literal"><span class="pre">STLS</span></code> command introduced
in <span class="target" id="index-3"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2595.html"><strong>RFC 2595</strong></a> to enable encrypted communication on an already established connection.</p>
<p>Additionally, this module provides a class <a class="reference internal" href="#poplib.POP3_SSL" title="poplib.POP3_SSL"><code class="xref py py-class docutils literal"><span class="pre">POP3_SSL</span></code></a>, which provides
support for connecting to POP3 servers that use SSL as an underlying protocol
layer.</p>
<p>Note that POP3, though widely supported, is obsolescent.  The implementation
quality of POP3 servers varies widely, and too many are quite poor. If your
mailserver supports IMAP, you would be better off using the
<a class="reference internal" href="imaplib.html#imaplib.IMAP4" title="imaplib.IMAP4"><code class="xref py py-class docutils literal"><span class="pre">imaplib.IMAP4</span></code></a> class, as IMAP servers tend to be better implemented.</p>
<p>The <a class="reference internal" href="#module-poplib" title="poplib: POP3 protocol client (requires sockets)."><code class="xref py py-mod docutils literal"><span class="pre">poplib</span></code></a> module provides two classes:</p>
<dl class="class">
<dt id="poplib.POP3">
<em class="property">class </em><code class="descclassname">poplib.</code><code class="descname">POP3</code><span class="sig-paren">(</span><em>host</em>, <em>port=POP3_PORT</em><span class="optional">[</span>, <em>timeout</em><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#poplib.POP3" title="Permalink to this definition">¶</a></dt>
<dd><p>This class implements the actual POP3 protocol.  The connection is created when
the instance is initialized. If <em>port</em> is omitted, the standard POP3 port (110)
is used. The optional <em>timeout</em> parameter specifies a timeout in seconds for the
connection attempt (if not specified, the global default timeout setting will
be used).</p>
</dd></dl>

<dl class="class">
<dt id="poplib.POP3_SSL">
<em class="property">class </em><code class="descclassname">poplib.</code><code class="descname">POP3_SSL</code><span class="sig-paren">(</span><em>host</em>, <em>port=POP3_SSL_PORT</em>, <em>keyfile=None</em>, <em>certfile=None</em>, <em>timeout=None</em>, <em>context=None</em><span class="sig-paren">)</span><a class="headerlink" href="#poplib.POP3_SSL" title="Permalink to this definition">¶</a></dt>
<dd><p>This is a subclass of <a class="reference internal" href="#poplib.POP3" title="poplib.POP3"><code class="xref py py-class docutils literal"><span class="pre">POP3</span></code></a> that connects to the server over an SSL
encrypted socket.  If <em>port</em> is not specified, 995, the standard POP3-over-SSL
port is used.  <em>timeout</em> works as in the <a class="reference internal" href="#poplib.POP3" title="poplib.POP3"><code class="xref py py-class docutils literal"><span class="pre">POP3</span></code></a> constructor.
<em>context</em> is an optional <a class="reference internal" href="ssl.html#ssl.SSLContext" title="ssl.SSLContext"><code class="xref py py-class docutils literal"><span class="pre">ssl.SSLContext</span></code></a> object which allows
bundling SSL configuration options, certificates and private keys into a
single (potentially long-lived) structure.  Please read <a class="reference internal" href="ssl.html#ssl-security"><span>Security considerations</span></a>
for best practices.</p>
<p><em>keyfile</em> and <em>certfile</em> are a legacy alternative to <em>context</em> - they can
point to PEM-formatted private key and certificate chain files,
respectively, for the SSL connection.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.2: </span><em>context</em> parameter added.</p>
</div>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.4: </span>The class now supports hostname check with
<a class="reference internal" href="ssl.html#ssl.SSLContext.check_hostname" title="ssl.SSLContext.check_hostname"><code class="xref py py-attr docutils literal"><span class="pre">ssl.SSLContext.check_hostname</span></code></a> and <em>Server Name Indication</em> (see
<a class="reference internal" href="ssl.html#ssl.HAS_SNI" title="ssl.HAS_SNI"><code class="xref py py-data docutils literal"><span class="pre">ssl.HAS_SNI</span></code></a>).</p>
</div>
</dd></dl>

<p>One exception is defined as an attribute of the <a class="reference internal" href="#module-poplib" title="poplib: POP3 protocol client (requires sockets)."><code class="xref py py-mod docutils literal"><span class="pre">poplib</span></code></a> module:</p>
<dl class="exception">
<dt id="poplib.error_proto">
<em class="property">exception </em><code class="descclassname">poplib.</code><code class="descname">error_proto</code><a class="headerlink" href="#poplib.error_proto" title="Permalink to this definition">¶</a></dt>
<dd><p>Exception raised on any errors from this module (errors from <a class="reference internal" href="socket.html#module-socket" title="socket: Low-level networking interface."><code class="xref py py-mod docutils literal"><span class="pre">socket</span></code></a>
module are not caught). The reason for the exception is passed to the
constructor as a string.</p>
</dd></dl>

<div class="admonition seealso">
<p class="first admonition-title">See also</p>
<dl class="last docutils">
<dt>Module <a class="reference internal" href="imaplib.html#module-imaplib" title="imaplib: IMAP4 protocol client (requires sockets)."><code class="xref py py-mod docutils literal"><span class="pre">imaplib</span></code></a></dt>
<dd>The standard Python IMAP module.</dd>
<dt><a class="reference external" href="http://www.catb.org/~esr/fetchmail/fetchmail-FAQ.html">Frequently Asked Questions About Fetchmail</a></dt>
<dd>The FAQ for the <strong class="program">fetchmail</strong> POP/IMAP client collects information on
POP3 server variations and RFC noncompliance that may be useful if you need to
write an application based on the POP protocol.</dd>
</dl>
</div>
<div class="section" id="pop3-objects">
<span id="id1"></span><h2>21.14.1. POP3 Objects<a class="headerlink" href="#pop3-objects" title="Permalink to this headline">¶</a></h2>
<p>All POP3 commands are represented by methods of the same name, in lower-case;
most return the response text sent by the server.</p>
<p>An <a class="reference internal" href="#poplib.POP3" title="poplib.POP3"><code class="xref py py-class docutils literal"><span class="pre">POP3</span></code></a> instance has the following methods:</p>
<dl class="method">
<dt id="poplib.POP3.set_debuglevel">
<code class="descclassname">POP3.</code><code class="descname">set_debuglevel</code><span class="sig-paren">(</span><em>level</em><span class="sig-paren">)</span><a class="headerlink" href="#poplib.POP3.set_debuglevel" title="Permalink to this definition">¶</a></dt>
<dd><p>Set the instance&#8217;s debugging level.  This controls the amount of debugging
output printed.  The default, <code class="docutils literal"><span class="pre">0</span></code>, produces no debugging output.  A value of
<code class="docutils literal"><span class="pre">1</span></code> produces a moderate amount of debugging output, generally a single line
per request.  A value of <code class="docutils literal"><span class="pre">2</span></code> or higher produces the maximum amount of
debugging output, logging each line sent and received on the control connection.</p>
</dd></dl>

<dl class="method">
<dt id="poplib.POP3.getwelcome">
<code class="descclassname">POP3.</code><code class="descname">getwelcome</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#poplib.POP3.getwelcome" title="Permalink to this definition">¶</a></dt>
<dd><p>Returns the greeting string sent by the POP3 server.</p>
</dd></dl>

<dl class="method">
<dt id="poplib.POP3.capa">
<code class="descclassname">POP3.</code><code class="descname">capa</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#poplib.POP3.capa" title="Permalink to this definition">¶</a></dt>
<dd><p>Query the server&#8217;s capabilities as specified in <span class="target" id="index-4"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2449.html"><strong>RFC 2449</strong></a>.
Returns a dictionary in the form <code class="docutils literal"><span class="pre">{'name':</span> <span class="pre">['param'...]}</span></code>.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.4.</span></p>
</div>
</dd></dl>

<dl class="method">
<dt id="poplib.POP3.user">
<code class="descclassname">POP3.</code><code class="descname">user</code><span class="sig-paren">(</span><em>username</em><span class="sig-paren">)</span><a class="headerlink" href="#poplib.POP3.user" title="Permalink to this definition">¶</a></dt>
<dd><p>Send user command, response should indicate that a password is required.</p>
</dd></dl>

<dl class="method">
<dt id="poplib.POP3.pass_">
<code class="descclassname">POP3.</code><code class="descname">pass_</code><span class="sig-paren">(</span><em>password</em><span class="sig-paren">)</span><a class="headerlink" href="#poplib.POP3.pass_" title="Permalink to this definition">¶</a></dt>
<dd><p>Send password, response includes message count and mailbox size. Note: the
mailbox on the server is locked until <code class="xref py py-meth docutils literal"><span class="pre">quit()</span></code> is called.</p>
</dd></dl>

<dl class="method">
<dt id="poplib.POP3.apop">
<code class="descclassname">POP3.</code><code class="descname">apop</code><span class="sig-paren">(</span><em>user</em>, <em>secret</em><span class="sig-paren">)</span><a class="headerlink" href="#poplib.POP3.apop" title="Permalink to this definition">¶</a></dt>
<dd><p>Use the more secure APOP authentication to log into the POP3 server.</p>
</dd></dl>

<dl class="method">
<dt id="poplib.POP3.rpop">
<code class="descclassname">POP3.</code><code class="descname">rpop</code><span class="sig-paren">(</span><em>user</em><span class="sig-paren">)</span><a class="headerlink" href="#poplib.POP3.rpop" title="Permalink to this definition">¶</a></dt>
<dd><p>Use RPOP authentication (similar to UNIX r-commands) to log into POP3 server.</p>
</dd></dl>

<dl class="method">
<dt id="poplib.POP3.stat">
<code class="descclassname">POP3.</code><code class="descname">stat</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#poplib.POP3.stat" title="Permalink to this definition">¶</a></dt>
<dd><p>Get mailbox status.  The result is a tuple of 2 integers: <code class="docutils literal"><span class="pre">(message</span> <span class="pre">count,</span>
<span class="pre">mailbox</span> <span class="pre">size)</span></code>.</p>
</dd></dl>

<dl class="method">
<dt id="poplib.POP3.list">
<code class="descclassname">POP3.</code><code class="descname">list</code><span class="sig-paren">(</span><span class="optional">[</span><em>which</em><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#poplib.POP3.list" title="Permalink to this definition">¶</a></dt>
<dd><p>Request message list, result is in the form <code class="docutils literal"><span class="pre">(response,</span> <span class="pre">['mesg_num</span> <span class="pre">octets',</span>
<span class="pre">...],</span> <span class="pre">octets)</span></code>. If <em>which</em> is set, it is the message to list.</p>
</dd></dl>

<dl class="method">
<dt id="poplib.POP3.retr">
<code class="descclassname">POP3.</code><code class="descname">retr</code><span class="sig-paren">(</span><em>which</em><span class="sig-paren">)</span><a class="headerlink" href="#poplib.POP3.retr" title="Permalink to this definition">¶</a></dt>
<dd><p>Retrieve whole message number <em>which</em>, and set its seen flag. Result is in form
<code class="docutils literal"><span class="pre">(response,</span> <span class="pre">['line',</span> <span class="pre">...],</span> <span class="pre">octets)</span></code>.</p>
</dd></dl>

<dl class="method">
<dt id="poplib.POP3.dele">
<code class="descclassname">POP3.</code><code class="descname">dele</code><span class="sig-paren">(</span><em>which</em><span class="sig-paren">)</span><a class="headerlink" href="#poplib.POP3.dele" title="Permalink to this definition">¶</a></dt>
<dd><p>Flag message number <em>which</em> for deletion.  On most servers deletions are not
actually performed until QUIT (the major exception is Eudora QPOP, which
deliberately violates the RFCs by doing pending deletes on any disconnect).</p>
</dd></dl>

<dl class="method">
<dt id="poplib.POP3.rset">
<code class="descclassname">POP3.</code><code class="descname">rset</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#poplib.POP3.rset" title="Permalink to this definition">¶</a></dt>
<dd><p>Remove any deletion marks for the mailbox.</p>
</dd></dl>

<dl class="method">
<dt id="poplib.POP3.noop">
<code class="descclassname">POP3.</code><code class="descname">noop</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#poplib.POP3.noop" title="Permalink to this definition">¶</a></dt>
<dd><p>Do nothing.  Might be used as a keep-alive.</p>
</dd></dl>

<dl class="method">
<dt id="poplib.POP3.quit">
<code class="descclassname">POP3.</code><code class="descname">quit</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#poplib.POP3.quit" title="Permalink to this definition">¶</a></dt>
<dd><p>Signoff:  commit changes, unlock mailbox, drop connection.</p>
</dd></dl>

<dl class="method">
<dt id="poplib.POP3.top">
<code class="descclassname">POP3.</code><code class="descname">top</code><span class="sig-paren">(</span><em>which</em>, <em>howmuch</em><span class="sig-paren">)</span><a class="headerlink" href="#poplib.POP3.top" title="Permalink to this definition">¶</a></dt>
<dd><p>Retrieves the message header plus <em>howmuch</em> lines of the message after the
header of message number <em>which</em>. Result is in form <code class="docutils literal"><span class="pre">(response,</span> <span class="pre">['line',</span> <span class="pre">...],</span>
<span class="pre">octets)</span></code>.</p>
<p>The POP3 TOP command this method uses, unlike the RETR command, doesn&#8217;t set the
message&#8217;s seen flag; unfortunately, TOP is poorly specified in the RFCs and is
frequently broken in off-brand servers. Test this method by hand against the
POP3 servers you will use before trusting it.</p>
</dd></dl>

<dl class="method">
<dt id="poplib.POP3.uidl">
<code class="descclassname">POP3.</code><code class="descname">uidl</code><span class="sig-paren">(</span><em>which=None</em><span class="sig-paren">)</span><a class="headerlink" href="#poplib.POP3.uidl" title="Permalink to this definition">¶</a></dt>
<dd><p>Return message digest (unique id) list. If <em>which</em> is specified, result contains
the unique id for that message in the form <code class="docutils literal"><span class="pre">'response</span> <span class="pre">mesgnum</span> <span class="pre">uid</span></code>, otherwise
result is list <code class="docutils literal"><span class="pre">(response,</span> <span class="pre">['mesgnum</span> <span class="pre">uid',</span> <span class="pre">...],</span> <span class="pre">octets)</span></code>.</p>
</dd></dl>

<dl class="method">
<dt id="poplib.POP3.utf8">
<code class="descclassname">POP3.</code><code class="descname">utf8</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#poplib.POP3.utf8" title="Permalink to this definition">¶</a></dt>
<dd><p>Try to switch to UTF-8 mode. Returns the server response if successful,
raises <a class="reference internal" href="#poplib.error_proto" title="poplib.error_proto"><code class="xref py py-class docutils literal"><span class="pre">error_proto</span></code></a> if not. Specified in <span class="target" id="index-5"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc6856.html"><strong>RFC 6856</strong></a>.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.5.</span></p>
</div>
</dd></dl>

<dl class="method">
<dt id="poplib.POP3.stls">
<code class="descclassname">POP3.</code><code class="descname">stls</code><span class="sig-paren">(</span><em>context=None</em><span class="sig-paren">)</span><a class="headerlink" href="#poplib.POP3.stls" title="Permalink to this definition">¶</a></dt>
<dd><p>Start a TLS session on the active connection as specified in <span class="target" id="index-6"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2595.html"><strong>RFC 2595</strong></a>.
This is only allowed before user authentication</p>
<p><em>context</em> parameter is a <a class="reference internal" href="ssl.html#ssl.SSLContext" title="ssl.SSLContext"><code class="xref py py-class docutils literal"><span class="pre">ssl.SSLContext</span></code></a> object which allows
bundling SSL configuration options, certificates and private keys into
a single (potentially long-lived) structure.  Please read <a class="reference internal" href="ssl.html#ssl-security"><span>Security considerations</span></a>
for best practices.</p>
<p>This method supports hostname checking via
<a class="reference internal" href="ssl.html#ssl.SSLContext.check_hostname" title="ssl.SSLContext.check_hostname"><code class="xref py py-attr docutils literal"><span class="pre">ssl.SSLContext.check_hostname</span></code></a> and <em>Server Name Indication</em> (see
<a class="reference internal" href="ssl.html#ssl.HAS_SNI" title="ssl.HAS_SNI"><code class="xref py py-data docutils literal"><span class="pre">ssl.HAS_SNI</span></code></a>).</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.4.</span></p>
</div>
</dd></dl>

<p>Instances of <a class="reference internal" href="#poplib.POP3_SSL" title="poplib.POP3_SSL"><code class="xref py py-class docutils literal"><span class="pre">POP3_SSL</span></code></a> have no additional methods. The interface of this
subclass is identical to its parent.</p>
</div>
<div class="section" id="pop3-example">
<span id="id2"></span><h2>21.14.2. POP3 Example<a class="headerlink" href="#pop3-example" title="Permalink to this headline">¶</a></h2>
<p>Here is a minimal example (without error checking) that opens a mailbox and
retrieves and prints all messages:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="kn">import</span> <span class="nn">getpass</span><span class="o">,</span> <span class="nn">poplib</span>

<span class="n">M</span> <span class="o">=</span> <span class="n">poplib</span><span class="o">.</span><span class="n">POP3</span><span class="p">(</span><span class="s">&#39;localhost&#39;</span><span class="p">)</span>
<span class="n">M</span><span class="o">.</span><span class="n">user</span><span class="p">(</span><span class="n">getpass</span><span class="o">.</span><span class="n">getuser</span><span class="p">())</span>
<span class="n">M</span><span class="o">.</span><span class="n">pass_</span><span class="p">(</span><span class="n">getpass</span><span class="o">.</span><span class="n">getpass</span><span class="p">())</span>
<span class="n">numMessages</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">M</span><span class="o">.</span><span class="n">list</span><span class="p">()[</span><span class="mi">1</span><span class="p">])</span>
<span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">numMessages</span><span class="p">):</span>
    <span class="k">for</span> <span class="n">j</span> <span class="ow">in</span> <span class="n">M</span><span class="o">.</span><span class="n">retr</span><span class="p">(</span><span class="n">i</span><span class="o">+</span><span class="mi">1</span><span class="p">)[</span><span class="mi">1</span><span class="p">]:</span>
        <span class="nb">print</span><span class="p">(</span><span class="n">j</span><span class="p">)</span>
</pre></div>
</div>
<p>At the end of the module, there is a test section that contains a more extensive
example of usage.</p>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../contents.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">21.14. <code class="docutils literal"><span class="pre">poplib</span></code> &#8212; POP3 protocol client</a><ul>
<li><a class="reference internal" href="#pop3-objects">21.14.1. POP3 Objects</a></li>
<li><a class="reference internal" href="#pop3-example">21.14.2. POP3 Example</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="ftplib.html"
                        title="previous chapter">21.13. <code class="docutils literal"><span class="pre">ftplib</span></code> &#8212; FTP protocol client</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="imaplib.html"
                        title="next chapter">21.15. <code class="docutils literal"><span class="pre">imaplib</span></code> &#8212; IMAP4 protocol client</a></p>
<h3>This Page</h3>
<ul class="this-page-menu">
  <li><a href="../bugs.html">Report a Bug</a></li>
  <li><a href="../_sources/library/poplib.txt"
         rel="nofollow">Show Source</a></li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="imaplib.html" title="21.15. imaplib — IMAP4 protocol client"
             >next</a> |</li>
        <li class="right" >
          <a href="ftplib.html" title="21.13. ftplib — FTP protocol client"
             >previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="internet.html" >21. Internet Protocols and Support</a> &raquo;</li> 
      </ul>
    </div>  
    <div class="footer">
    &copy; <a href="../copyright.html">Copyright</a> 1990-2016, Python Software Foundation.
    <br />
    The Python Software Foundation is a non-profit corporation.
    <a href="https://www.python.org/psf/donations/">Please donate.</a>
    <br />
    Last updated on Jan 08, 2016.
    <a href="../bugs.html">Found a bug</a>?
    <br />
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.3.3.
    </div>

  </body>
</html>